; - 60th SMT LEDs Luminous Design Clock -
;
; *** Main Program
; Version. 1.2b  (Last Update: 2007/02/28)
; Designed / Copyrights
;	M-Tech Design Inc.
;
;*** Notice 
;It's prohibited to use for any commercial purpose without permission.
;Contuct Us: info@m-techdi.com



.include "m8515def.inc"		

;const assign

;portB ------ DMD(Dot-Matrix Display) Control Line Assign
.equ	nRST	=0
.equ	nFL	=1
.equ	DA0	=2
.equ	DA1	=3
.equ	nWR	=4
.equ	DA2	=5
.equ	DA3	=6
.equ	DA4	=7

;portD ------ HC164(8bit Shift-Register) & 2 SWs Assign
.equ	SRin	=5
.equ	Sclk	=6
.equ	nSclr	=4
.equ	nSW1	=3
.equ	nSW2	=2
;.equ	RX	=0
;.equ	TX	=1

;dimmer const ------ Kݒl
.equ	dim_0	=0b00000000	;K0:
.equ	dim_1	=0b00000001	;1
.equ	dim_2	=0b00000010	;2
.equ	dim_3	=0b00000100	;3
.equ	dim_4	=0b00001000	;4
.equ	dim_5	=0b00010000	;5
.equ	dim_6	=0b00100000	;6
.equ	dim_7	=0b01000000	;7
.equ	dim_8	=0b10000000	;8:100%_

;SW Flag bit ------ SW̓tO`
;SWFlag[(x),(x),sw1on,sw1off,sw2on,sw2off,Fsw1st,Fst2st]

.equ	sw1on	=5
.equ	sw1off	=4
.equ	sw2on	=3
.equ	sw2off	=2
.equ	Fsw1st	=1
.equ	Fsw2st	=0

;DMD Scroll Counter
.equ	C_DMD_SCC = 6
;------------------------------------------- MACRO Define 

.macro	ldiw
	ldi	@0L,low(@1)
	ldi	@0H,high(@1)
.endm

.macro	outi		; outi	IO,imm 
	ldi	r16,@1
	out	@0,r16
.endm

.macro	sti
	ldi	r16,@1
	st	@0,r16
.endm

.macro	stdi
	ldi	r16,@1
	std	@0,r16
.endm

.macro debugp
	ldi	r16,@0
	call	TX_POLL
.endm

;---------------------------------------
;reg assign


.def	ZEROR		=r1	;"ZERO REG"
.def	STSTS		=r2	;status reg store
.def	TimeH		=r3	;Clock counter H (1 hour/LSB)
.def	TimeM		=r4	;Clock counter M (1 min/LSB)
.def	TimeS		=r5	;Clock counter S (1 sec/LSB)
.def	dim		=r6	;dim counter(18)
.def	frameF		=r7	;frame incrementation FLAG
.def	timeF		=r8	;time incrementation FLAG
.def	tempi4		=r9	;temp for INT

.def	temp3		=r10
.def	temp4		=r11
.def	temp5		=r12
.def	temp6		=r13
.def	temp7		=r14
.def	mode_t		=r15	;


.def	temp		=r16
.def	temp2		=r17
.def	tempi2		=r18	;temp for INT
.def	tempi3		=r19	;temp for INT
.def	line		=r20	;line counter(7)
.def	SWFlag		=r21	;SWFlag[(x),(x),sw1on,sw1off,sw2on,sw2off,Fsw1st,Fsw2st]
.def	frame		=r22	;Frame counter (31)
.def	mode_s		=r23	;60th LEDs indicate mode select
.def	mode_tsm	=r24	;Time-set mode select

.def	DMD_SCC		=r25	;DMD scroll counter
.def	loop		=r26	;Loop Counter
.def	RXTOC		=r27	;RX TimeOut Counter
.def	XL		=r26
.def	XH		=r27
.def	YL		=r28	;
.def	YH		=r29	; for interrupt
.def	ZL		=r30	;
.def	ZH		=r31	; for normal

;SRAM Assign -------------------------------------------------------------------------

.DSEG

leddot:		.byte	60	;leddot[0:59] 60th LED
				;Parameter: dim0..di8 [xxxx xxxx]
DMD_C:		.byte	70	;Dot Matrix Display 8chr
SW1_s:		.byte	1	;SW1 and SW2 state (8bit*2)
SW2_s:		.byte	1
F_Mode:		.byte	1	;Flash Mode select (n)
dim_tb:		.byte	18	;dimmer parameter(18 steps)
dim_fs:		.byte	32	;dimmer parameter(per 31 flames)
dim_fs2:	.byte	32	;dimmer parameter2(per 31 flames)
RXtemp:		.byte	72	;for Serial Interface mode buffer
MODES:		.byte	1	;dotled display mode Select
MODET:		.byte	1	;Time Display mode Select
DMDSTA:		.byte	1	;DMD charactor start address(default=0)
DMDNUM:		.byte	1	;DMD charactor Number(>8)
DMDDIM:		.byte	1	;DMD Dimmer set (0-8 3LSB)
LEDDIM:		.byte	1	;LED Dimmer set (0-3)
TSM_TH:		.byte	1
TSM_TM:		.byte	1
RXTOS:		.byte	1	;RXMode Timeout Parameter
;dimmer parameter
; 0:0000 0000 0000 0000 00 (0%)  all0 =0000 0000
; 2:0000 0000 1000 0000 01 (11%) bit0 =1000 0000
; 4:0001 0000 1000 1000 01 (22%) bit1 =0100 0000
; 6:0010 0100 1001 0010 01 (33%) bit2 =0010 0000
; 9:0101 0101 0101 0101 01 (50%) bit3 =0001 0000
;11:1101 1011 0110 1101 10 (66%) bit4 =0000 1000 
;14:1110 1111 0111 0111 10 (77%) bit5 =0000 0100
;16:1111 1111 0111 1111 10 (88%) bit6 =0000 0010
;18:1111 1111 1111 1111 11 (100%)bit7 =0000 0001

;----------------------------
;dimmer table dim1(bit0) -> dim8(bit7) and dim0(All0)
;	Q1	Q2	Q3	Q4	Q5	Q6	Q7
;C7	11	17	26	35	44	53	2
;C6	12	18	27	36	45	54	3
;C5	13	19	28	37	46	55	4
;C4	14	20	29	38	47	56	5
;C3	6		21	30	39	48	57
;C2	7		22	31	40	49	58
;C1	8		23	32	41	50	59
;C0	9	15	24	33	42	51	0
;D7	10	16	25	34	43	52	1

;-----------------------------------------


;Interrupt Vector Table -------------------------------------------------------------------------------- program code

.CSEG

	rjmp	RESET		;Reset Vector
	reti			;External Interrupt0 Vector Address
	reti			;External Interrupt1 Vector Address
	reti			;Input Capture1 Interrupt Vector Address
	reti			;Output Compare1A Interrupt Vector Address
	reti			;Output Compare1B Interrupt Vector Address
	reti			;Overflow1 Interrupt Vector Address
	rjmp	T0_INT		;Overflow0 Interrupt Vector Address
	reti			;SPI Interrupt Vector Address
	reti			;UART Receive Complete Interrupt Vector Address
	reti			;UART Data Register Empty Interrupt Vector Address
	reti			;UART Transmit Complete Interrupt Vector Address
	reti			;Analog Comparator Interrupt Vector Address
	reti			;External Interrupt2
	reti			;Timer/Counter0 Compare Match
	reti			;EEPROM Ready
	reti			;Store Program memory ready

;----------------- Interrupt routine
INT_ROUTINE:
.include "leddot3m3_int.asm"

;                    -------------------------------------------------------------------------------- main routine

	

RESET:
	cli				; Interrupt Disable

	sbi	ACSR,ACD		;Analog Comparator Disable (reduce power comp)
		
	outi	TCNT0,(256-4)	;Timer Counter default (64us*4=256us 1024 steps) 
	outi	TCCR0,0b00000100	;TIMER0 clk/256
	outi	TIMSK,0b00000010	;Timer0 Int enable

	outi	SPH,high(RAMEND)
	outi	SPL,low(RAMEND)
	outi	DDRA,0xff		;PORTA  all output (HDSP-211x Databus)
	outi	PORTA,0x00		;	default =0
	
	outi	DDRB,0xff		;PORTB all OUTPUT (LED drive-2)
	outi	PORTB,0b00010011	;	default =0

	outi	DDRC,0xff		;PORTC all output LED sink-2
	outi	PORTC,0xff		;	default =1(off)

	outi	DDRD,0b11110000		;PORTD 7:out(LED sink) 6-4 out(HC164 drive) 3:sw1/2:sw2
	outi	PORTD,0b10101100	;	default =0

	outi	DDRE,0xff		;PORTE all output
	outi	PORTE,0x00		;	default = 0


	outi	UCSRA,0x00		;8bit non-parity stop:1bit
	outi	UCSRC,(1<<URSEL)|(1<<UCSZ1)|(1<<UCSZ0)
	outi	UBRRH,0x00		;19200bps@4MHz/(U2X=0)
	outi	UBRRL,12
;-------------
	cbi	PORTD,nSClr	;clr=active
	cbi	PORTD,SRin	;SRin=L(initial)
	sbi	PORTD,Sclk
	clr	ZEROR
	clr	TimeH		;Clock counter H (1 hour/LSB)
	clr	TimeM		;Clock counter M (1 min/LSB)
	clr	TimeS		;Clock counter S (1 sec/LSB)
	clr	frame		;Frame counter (31)
	clr	dim		;dim counter(18)
	clr	line		;line counter(7)
	clr	frameF		;frame incrementation FLAG
	clr	timeF		;time incrementation FLAG
	clr	line		;line counter(7)
	clr	SWFlag		;SWFlag[Fsw1on,Fsw1off,Fsw2on,Fsw2off,sw1on,sw1off,sw2on,sw2off]
	clr	loop
	ldi	mode_s,9	;power on reset mode=9
	ldi	temp,0
	mov	mode_t,temp
	clr	temp7
	clr	temp6
	clr	mode_tsm
	ldi	DMD_SCC,C_DMD_SCC	;Set DMD_Scroll counter
	clr	RXTOC
	sts	RXTOS,ZEROR
	sts	LEDDIM,ZEROR	
	call	INIT_SRAM		;SRAM/DMD initialize
	rcall	DMDINI
	call	MOD_SET
	
;--------------------------------------------------------------------------------------------

	sei	;Interrupt Enable

INITIAL:
	sbic	PIND,nSW1
	rjmp	NORMAL_MODE	;nSW2->off
	sbic	PIND,nSW2	;->on
	rjmp	IN_SERIALM	;nSW1=off
	
IN_TESTM:
	sbic	PIND,nSW1
	rjmp	NORMAL_MODE
	sbic	PIND,nSW2
	rjmp	NORMAL_MODE
	mov	temp,TimeS
	cpi	temp,3
	breq	TEST_MODE
	rjmp	IN_TESTM

;----------------------------------
TEST_MODE:

	ldi	loop,30
	ldiw	Z,leddot

TMC0_L1:
	sti	Z+,dim_1
	sti	Z+,dim_0
	dec	loop
	brne	TMC0_L1		;30th*2 loop

	outi	PORTA,0b10101010
	outi	PORTB,0b01010101

TM_TFHIT1:	
	ldi	temp,0xff
	cp	timeF,temp
	brne	TM_TFHIT1
	;----TFlag hit(1sec)
	clr	timeF

	ldi	loop,30
	ldiw	Z,leddot

TMC0_L2:
	sti	Z+,dim_0
	sti	Z+,dim_1
	dec	loop
	brne	TMC0_L2		;30th*2 loop

	outi	PORTA,0b01010101
	outi	PORTB,0b10101010

TM_TFHIT2:	
	ldi	temp,0xff
	cp	timeF,temp
	brne	TM_TFHIT2
	;----TFlag hit(1sec)
	clr	timeF

	rjmp	TEST_MODE

;----------------------------------------------
IN_SERIALM:
	ldiw	Z,DMD_C		;loop=0 initialize
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,'>'
	sti	Z+,'L'
	sti	Z+,'i'
	sti	Z+,'n'
	sti	Z+,'k';8
	sti	Z+,'.'
	sti	Z+,'.'
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' ';16
	sti	Z+,' '
	sti	Z+,' ';18
	ldi	temp,0
	ldi	temp2,18
	sts	DMDSTA,temp
	sts	DMDNUM,temp2
;	rcall	DSENDS
	clr	mode_s		;serial mode(=0)
	clr	mode_t		;Time Display mode(=0)
	outi	UCSRB,(1<<RXEN)|(1<<TXEN)	;TX/RX Enable
	nop
	nop
	nop
	debugp	'L'
	debugp	'i'
	debugp	'n'
	debugp	'k'
;---------------------------------
SERIAL_MODE:

	call	SERIAL_RX

S_TFLAG_HIT:	
	ldi	temp,0xff
	cp	timeF,temp
	brne	SM_L1
	;----TFlag hit(1sec)
	clr	timeF
	rcall	TMODEJMP
SM_L1:
S_FFLAG_HIT:

	ldi	temp,0xff
	cp	frameF,temp
	brne	SERIAL_MODE
	;----FFlag hit(1/31sec)
	clr	frameF
	rcall	SW_CNT		;SW_status check
;------------
	dec	DMD_SCC
	brne	SM_L2
	ldi	DMD_SCC,C_DMD_SCC
	rcall	DSENDS
SM_L2:	
;------------	
	rcall	SMODEJMP
	rjmp	SERIAL_MODE

;---------------------------------------------

	

;--------------------------
NORMAL_MODE:
TFLAG_HIT:	
	ldi	temp,0xff
	cp	timeF,temp
	brne	MP_L1
	;----TFlag hit(1sec)
	clr	timeF
	rcall	TMODEJMP
MP_L1:
FFLAG_HIT:

	ldi	temp,0xff
	cp	frameF,temp
	brne	NORMAL_MODE
	;----FFlag hit(1/31sec)
	clr	frameF
	rcall	SW_CNT		;SW_status check
;------------
	dec	DMD_SCC
	brne	MP_L2
	ldi	DMD_SCC,C_DMD_SCC
	call	DSENDS
MP_L2:	
;------------	
	rcall	SW1DIT	;sw1 ditect & control
	rcall	SW2DIT
	rcall	SMODEJMP
	rjmp	NORMAL_MODE


;---------------------------------------------




;---------------------------------------------------
;----- DMD Time indicate
TMODEJMP:
	mov	temp2,mode_t
	cpi	temp2,1
	brne	DMDPS_1
	rcall	DMDINC		;DMD 1sec inc(24h)
	ret	
DMDPS_1:
	cpi	temp2,2
	brne	DMDPS_2
	rcall	DMDINC2		;DMD 1sec inc(12h)
DMDPS_2:
	ret




;----- 60th LEDs Effect mode jump & LED Draw
SMODEJMP:
	mov	temp,mode_s
	andi	temp,0b01111111	

	cpi	temp,1
	brne	PC+5
	sbrs	mode_s,7
	rcall	MODE_1INI
	rcall	MODE_1
	rjmp	PS_SMJMP


	cpi	temp,2
	brne	PC+5
	sbrs	mode_s,7
	rcall	MODE_2INI
	rcall	MODE_2
	rjmp	PS_SMJMP

	cpi	temp,3
	brne	PC+5
	sbrs	mode_s,7
	rcall	MODE_3INI
	rcall	MODE_3
	rjmp	PS_SMJMP

	cpi	temp,4
	brne	PC+5
	sbrs	mode_s,7
	rcall	MODE_4INI
	rcall	MODE_4
	rjmp	PS_SMJMP

	cpi	temp,5
	brne	PC+5
	sbrs	mode_s,7
	rcall	MODE_5INI
	rcall	MODE_5
	rjmp	PS_SMJMP

	cpi	temp,6
	brne	PC+5
	sbrs	mode_s,7
	rcall	MODE_6INI
	rcall	MODE_6
	rjmp	PS_SMJMP

	cpi	temp,7
	brne	PC+5
	sbrs	mode_s,7
	rcall	MODE_7INI
	rcall	MODE_7
	rjmp	PS_SMJMP

	cpi	temp,9
	brne	PC+3
	rcall	MODE_9
	rjmp	PS_SMJMP

PS_SMJMP:
	ori	mode_s,0b10000000
	ret

;--------------------------------------------
MODE_9:		;POWERON_Reset sequence

	rcall	MODE_1
	lds	temp,DMDSTA
	cpi	temp,66-8
	breq	M9_PS1
	ret

M9_PS1:
	ldi	temp,1
	mov	mode_t,temp
	ldi	temp,1
	mov	mode_s,temp
	ret

;--------------------------------------------------------------------------------------------
;------------------------------- *** subroutines ***
;---------------------------
WAITL:	
	clr	temp
	rcall	WAITS
	dec	temp2
	brne	WAITL
	ret

WAITS:	dec	temp
	brne	WAITS
	ret
		
;--------------------------------------------------------

.include "leddot3m3_led.asm"	;60th LED eGtFNg(`)FTu[eB
.include "leddot3m3_dmd.asm"	;DMD(Dot Matrix Module)Rg[/\FTu[eB
.include "leddot3m3_sws.asm"	;(Normal mode)SW͑Jڏ
.include "leddot3m3_ser.asm"	;Serial mode Jڏ
.include "leddot3m3_ini.asm"	;SRAM[eB
;--------------------------------------------------------


