;Interrupt DATAIN routine ------------------------
	.org	INT_ROUTINE


T0_INT:				;T0_int (64us*4=256us 1024 steps)

	in	STSTS,SREG	;stack Status 
	push	temp



	outi	TCNT0,(256-4)	;Timer Counter default 

;extra frame check 	frame=31?
	ldi	temp,31
	cp	frame,temp	;frame=31?
	brne	PS_EXFC		;->no
		clr	frame		;->yes frame=0 with Extra Flame
;----------------
	;timeF = FF & 1sec increment
		cbi	PORTD,nSClr	;Line Driver clr=active(Extra Flame)
		ldi	temp,0xff
		mov	timeF,temp	;time increment flag=FF(hit)

		ldi	temp,60
		inc	TimeS
		cp	TimeS,temp	;TimeS=60?
		brne	PS_1TINC	;->no
		clr	TimeS		;->yes TimeS=0
		inc	TimeM		
		cp	TimeM,temp	;TimeM=60?
		brne	PS_1TINC	;->no
		clr	TimeM		;TimeM=0
		inc	TimeH	
		ldi	temp,24
		cp	TimeH,temp	;TimeH=24?
		brne	PS_1TINC	;->no
		clr	TimeH		;->yes TimeH=0
	PS_1TINC:
		outi	TCNT0,(256-1)		;Extra Frame Timer set

	pop	temp
	out	SREG,STSTS	;restore stack & regs
	reti
;-----------------
PS_EXFC:			;reguler frame

//1C\
	cpi	line,0
	brne	PSTL1
	ldi	tempi2,6		;Line1(6-14)
				;Line Incremet(Line1)
	cbi	PORTD,nSClr	;clr=active
	nop
	nop
	sbi	PORTD,nSclr	;clr=inactive
	nop
	sbi	PORTD,SRin	;SRin=H(initial)
	nop

	sbi	PORTD,7		;sink PORT set (PORTC&D7)
	outi	PORTC,0xff	;sink LED all off

	cbi	PORTD,Sclk
	nop
	sbi	PORTD,Sclk	;clk=L->H (Line1 select)

	rcall	T_LINE

;	brts	PS_PD7L1
;	cbi	PORTD,7
;PS_PD7L1:	
;	out	PORTC,tempi3

	cbi	PORTD,SRin

	rjmp	TI_LINC

PSTL1:	cpi	line,1
	brne	PSTL2
	ldi	tempi2,12	;Line2(12-14 dummy,15-20)

	sbi	PORTD,7		;sink PORT set (PORTC&D7)
	outi	PORTC,0xff	;sink LED all off

	cbi	PORTD,Sclk
	nop
	sbi	PORTD,Sclk	;clk=L->H (Line2 select)

	rcall	T_LINE

;	brts	PS_PD7L2
;	cbi	PORTD,7
;PS_PD7L2:	
;	out	PORTC,tempi3

	rjmp	TI_LINC

PSTL2:	cpi	line,2
	brne	PSTL3
	ldi	tempi2,21	;Line3(21-29)

	sbi	PORTD,7		;sink PORT set (PORTC&D7)
	outi	PORTC,0xff	;sink LED all off

	cbi	PORTD,Sclk
	nop
	sbi	PORTD,Sclk	;clk=L->H (Line3 select)

	rcall	T_LINE

;	brts	PS_PD7L3
;	cbi	PORTD,7
;PS_PD7L3:	
;	out	PORTC,tempi3

	rjmp	TI_LINC

PSTL3:	cpi	line,3
	brne	PSTL4
	ldi	tempi2,30	;Line4(30-38)

	sbi	PORTD,7		;sink PORT set (PORTC&D7)
	outi	PORTC,0xff	;sink LED all off

	cbi	PORTD,Sclk
	nop
	sbi	PORTD,Sclk	;clk=L->H (Line4 select)

	rcall	T_LINE

;	brts	PS_PD7L4
;	cbi	PORTD,7
;PS_PD7L4:	
;	out	PORTC,tempi3

	rjmp	TI_LINC

PSTL4:	cpi	line,4
	brne	PSTL5
	ldi	tempi2,39	;Line5(39-47)

	sbi	PORTD,7		;sink PORT set (PORTC&D7)
	outi	PORTC,0xff	;sink LED all off

	cbi	PORTD,Sclk
	nop
	sbi	PORTD,Sclk	;clk=L->H (Line5 select)

	rcall	T_LINE

;	brts	PS_PD7L5
;	cbi	PORTD,7
;PS_PD7L5:	
;	out	PORTC,tempi3

	rjmp	TI_LINC

PSTL5:	cpi	line,5
	brne	PSTL6
	ldi	tempi2,48	;Line6(48-56)

	sbi	PORTD,7		;sink PORT set (PORTC&D7)
	outi	PORTC,0xff	;sink LED all off

	cbi	PORTD,Sclk
	nop
	sbi	PORTD,Sclk	;clk=L->H (Line6 select)

	rcall	T_LINE

;	brts	PS_PD7L6
;	cbi	PORTD,7
;PS_PD7L6:	
;	out	PORTC,tempi3

	rjmp	TI_LINC


PSTL6:	ldi	tempi2,57	;Line7(57-59,0-5)

	sbi	PORTD,7		;sink PORT set (PORTC&D7)
	outi	PORTC,0xff	;sink LED all off

	cbi	PORTD,Sclk
	nop
	sbi	PORTD,Sclk	;clk=L->H (Line2 select)

	rcall	T_LINE

;	brts	PS_PD7L7
;	cbi	PORTD,7
;PS_PD7L7:	
;	out	PORTC,tempi3


;--------------
TI_LINC:
	;counter increment
	inc	line
	ldi	temp,7
	cp	line,temp	;line=7?
	brne	PS_TICI0
	clr	line		;->yes line=0
	inc	dim
	ldi	temp,18
	cp	dim,temp	;dim=18?
	brne	PS_TICI0
	clr	dim		;->yes dim=0
	inc	frame
	inc	RXTOC
	ldi	temp,0xff
	mov	frameF,temp	;frameFlag=hit(FF)
PS_TICI0:


	
TI_SWD:				;SW ditect
	cp	line,ZEROR	;line=0?
	brne	PS_TISW		;->no
	lds	temp,SW1_s
	clc	
	sbic	PIND,nSW1	;nSW1=L pass
	sec
	rol	temp
	sts	SW1_s,temp
	
	lds	temp,SW2_s
	clc
	sbic	PIND,nSW2
	sec
	rol	temp
	sts	SW2_s,temp
PS_TISW:

	pop	temp
	out	SREG,STSTS	;restore stack & regs
	reti


;	//SW1 and SW2 state increment
;	line=0? (/per Flame)
;
;	PORT->SW1 and SW2
;	sw1bit ->SW1 state
;	sw2bit ->SW2 state
;
;	SW1 state=00 and sw1on=0
;		y->sw1off=1
;	SW1 state=FF and sw1off=0
;		y->sw1on=1
;	SW2 state=00 and sw2on=0
;		y->sw2off=1
;	SW2 state=FF and sw2off=0
;		y->sw2on=1

;--------------------	//Line Data Set function
T_LINE:
	ldi	YH,high(dim_tb)
	ldi	YL,low(dim_tb)	;Y=dim_tb	
	add	YL,dim
	adc	YH,ZEROR	;Y=Y+dim
	ld	tempi4,Y	;tempi4=dimmer table(dim)

	ldi	YH,high(leddot)
	ldi	YL,low(leddot)	;Y=leddot table
	add	YL,tempi2	
	adc	YH,ZEROR	;Y=Y+Line n (tempi2 start add)

	ldi	tempi3,0xff	;LED PORT buffer ALL H(LED=off)
	set			;tempi3=C3 and Tflag=D7

	ld	temp,Y+		;dot6 load
	and	temp,tempi4	;dimmer table *dot6
	breq	PS_TL11		;=0 ->pass
	andi	tempi3,0b11110111;=1 ->C3=ON
PS_TL11:
	ld	temp,Y+		;dot7 load
	and	temp,tempi4	;dimmer table *dot6
	breq	PS_TL12		;=0 ->pass
	andi	tempi3,0b11111011;=1 ->C2=ON
PS_TL12:
	ld	temp,Y+		;dot8 load
	and	temp,tempi4	;dimmer table *dot6
	breq	PS_TL13		;=0 ->pass
	andi	tempi3,0b11111101;=1 ->C1=ON	
PS_TL13:
	cpi	tempi2,57	;Line=7 select?
	brne	PS_TL57		;->no
	ldi	YH,high(leddot)	;->yes
	ldi	YL,low(leddot)	;Y=0
PS_TL57:	
	ld	temp,Y+		;dot9 load
	and	temp,tempi4	;dimmer table *dot6
	breq	PS_TL14		;=0 ->pass
	andi	tempi3,0b11111110;=1 ->C0=ON
PS_TL14:
	ld	temp,Y+		;dot10 load
	and	temp,tempi4	;dimmer table *dot6
	breq	PS_TL15		;=0 ->pass
	clt			;=1 ->D7=ON
PS_TL15:
	ld	temp,Y+		;dot11 load
	and	temp,tempi4	;dimmer table *dot6
	breq	PS_TL16		;=0 ->pass
	andi	tempi3,0b01111111;=1 ->C7=ON
PS_TL16:
	ld	temp,Y+		;dot12 load
	and	temp,tempi4	;dimmer table *dot6
	breq	PS_TL17		;=0 ->pass
	andi	tempi3,0b10111111;=1 ->C6=ON
PS_TL17:
	ld	temp,Y+		;dot13 load
	and	temp,tempi4	;dimmer table *dot6
	breq	PS_TL18		;=0 ->pass
	andi	tempi3,0b11011111;=1 ->C5=ON
PS_TL18:
	ld	temp,Y+		;dot14 load
	and	temp,tempi4	;dimmer table *dot6
	breq	PS_TL19		;=0 ->pass
	andi	tempi3,0b11101111;=1 ->C4=ON
PS_TL19:
	brts	PS_TL20
	cbi	PORTD,7
PS_TL20:	
	out	PORTC,tempi3

	ret
;----------------------------
;dimmer table dim1(bit0) -> dim8(bit7) and dim0(All0)
;	Q1	Q2	Q3	Q4	Q5	Q6	Q7
;C7	11	17	26	35	44	53	2
;C6	12	18	27	36	45	54	3
;C5	13	19	28	37	46	55	4
;C4	14	20	29	38	47	56	5
;C3	6		21	30	39	48	57
;C2	7		22	31	40	49	58
;C1	8		23	32	41	50	59
;C0	9	15	24	33	42	51	0
;D7	10	16	25	34	43	52	1

;-----------------------------------------

