;----------- in serial mode

;---------------------------------
.equ	ACK_OK		=0x55
.equ	ACK_NG		=0xAA
.equ	ACK_CHK		=0xff
.equ	ACK_FE		=0xee

;----------- subroutines
;---------	
RX_POLL:	;Rx 1byte Receive Flaming /Timeout ERR:T=1 /RXData:temp(r16)
	clt
	clr	RXTOC	;Timeout counter clear
RX_POL1:sbic	UCSRA,RXC
	rjmp	RX_POL2
	lds	temp,RXTOS
	cpi	temp,0
	breq	RX_POL1	
	cp	RXTOC,temp
	brcs	RX_POL1
	set
	ret

RX_POL2:sbic	UCSRA,FE
	set		
	in	temp,UDR
	ret
;------------------
RX_POLL_NT:	;Rx 1byte Receive (with No Time-out count)Flaming ERR:T=1 /RXData:temp(r16)
	clt
;	clr	RXTOC	;Timeout counter clear
RXN_POL1:
	sbis	UCSRA,RXC
	rjmp	RXN_POL1

	sbic	UCSRA,FE
	set		
	in	temp,UDR
	ret
;------------
TX_POLL:	;Tx 1byte Transmit
	sbis	UCSRA,UDRE
	rjmp	TX_POLL
	out	UDR,temp
	ret

;--------------------------------------------------------------------
SERIAL_RX:	;------- serial mode main routine

	sbis	UCSRA,RXC
	ret				;------ Return SERIAL_RX
	sbic	UCSRA,FE
	rjmp	ERR_RXFE	
	in	temp,UDR

;---------------			;1st charactor(Command) Received
	cpi	temp,0x01
	brne	PC+2
	rjmp	RXPM_A	;mode A 60th LED Drive
	cpi	temp,0x03
	brne	PC+2
	rjmp	RXPM_B	;mode B DMD charactor set
	cpi	temp,0x04
	brne	PC+2
	rjmp	RXPM_C	;mode C DMD Dimmer Set
	cpi	temp,0x05
	brne	PC+2
	rjmp	RXPM_D	;mode D DMD User Charactor set
	cpi	temp,0x06
	brne	PC+2
	rjmp	RXPM_E	;mode E mode_t set
	cpi	temp,0x07
	brne	PC+2
	rjmp	RXPM_F	;mode F mode_s set
	cpi	temp,0x08
	brne	PC+2
	rjmp	RXPM_G	;mode G DotLED Dim parameter set
	cpi	temp,0x02
	brne	PC+2
	rjmp	RXPM_H	;mode H once LED Drive
	cpi	temp,0x09
	brne	PC+2
	rjmp	RXPM_I	;mode I Time Set
	cpi	temp,0x0A
	brne	PC+2
	rjmp	RXPM_J	;mode J Timeout parameter set
	cpi	temp,0xff
	brne	PC+2
	rjmp	RXPM_ACK;mode ACK (check SM Idle)

	rjmp	ERR_RXDAT;other code ->ERR	
;---------------
RXPM_A:		;60th LED Set 1+60+1
	ldi	loop,60
	ldiw	Z,RXtemp
RXMA_L1:		;60times Receive (LED Dot Data)

	rcall	RX_POLL		
	brtc	PC+2	
	rjmp	ERR_RXFE	;Framing ERR(T=1)
	cpi	temp,0xff
	brne	PC+2
	rjmp	ERR_RXDAT	;Rxdata=0xff ->Data ERR (<60 times)
	st	Z+,temp
	dec	loop		;continue 60th
	brne	RXMA_L1

;--------
	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE	;Framing ERR(T=1)
	cpi	temp,0xff	;RXdata=0xff(finish)?
	breq	PC+2	
	rjmp	ERR_RXDAT	;->no Data ERR
				;->yes
	ldi	temp2,60	;RXtemp[0..59] ->leddot[0..59]
	ldiw	X,leddot
	ldiw	Z,RXtemp
;--------
RXMA_L2:		;Received data set RXtemp -> leddot
	ld	temp,Z+
	st	X+,temp
	dec	temp2
	brne	RXMA_L2
	
	debugp	ACK_OK		;Echo OK command
	rjmp	RXP_FIN

;------------------------
RXPM_B:		;DMD Charactor set 1+1+(70)+1
	ldiw	Z,RXtemp

	rcall	RX_POLL		;Charactor Number Received
	brtc	PC+2
	rjmp	ERR_RXFE	;->FE
	cpi	temp,0xff
	brne	PC+2
	rjmp	ERR_RXDAT	;(=0xFF) Data ERR
	cpi	temp,70
	brcs	PC+2
	rjmp	ERR_RXDAT	;(>70) Over ->DataERR
	cpi	temp,8
	brcc	PC+2
	rjmp	ERR_RXDAT	;(<8) Under ->DataERR
	st	Z+,temp
;----------
	mov	loop,temp	;Receive Charactor (CN Times)
RXMB_L1:
	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE	;->FE
	cpi	temp,0xff
	brne	PC+2
	rjmp	ERR_RXDAT	;(=0xff) Data ERR
	st	Z+,temp
	dec	loop
	brne	RXMB_L1
;----------
	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,0xff
	breq	PC+2
	rjmp	ERR_RXDAT

	ldiw	Z,RXtemp
	ld	temp2,Z+
	ldiw	X,DMD_C		;DMD Charactor Startadd

RXMB_L2:			;RXTemp -> DMD Charactor
	ld	temp,Z+
	st	X+,temp
	dec	temp2
	brne	RXMB_L2

	ldi	temp,0
	lds	temp2,RXtemp
	sts	DMDSTA,temp
	sts	DMDNUM,temp2
	
	debugp	ACK_OK
	rjmp	RXP_FIN

;----------------------------
RXPM_C:	;-------DMD Dimmer Control 1+1+1

	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,8		;dimmer parameter <8
	brcs	PC+2
	rjmp	ERR_RXDAT
	mov	temp2,temp

	rcall	RX_POLL		;Finish command
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,0xff
	breq	PC+2
	rjmp	ERR_RXDAT

	;--------- DMD Dimmer control register set
	;		temp2 send

	sts	DMDDIM,temp2
	;-----------------
	ldi	temp,0b10001000 ;all flash ram clear
	add	temp,temp2	 ;Dimmer parameter add
	out	PORTA,temp
	ldi	temp,0b10010011	;control word reg sel
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR
	;-----------------
	lds	temp2,DMDSTA
	cpi	temp2,0
	breq	PC+4	;sts=2word
	dec	temp2
	dec	temp2
	sts	DMDSTA,temp2	;DMD Start ADDress-2
;	rcall	DSENDS
	
	debugp	ACK_OK
	rjmp	RXP_FIN
		
;------------------------------------
RXPM_D:	;-------DMD Charactor Set 1+8+1
	ldiw	Z,RXtemp
	ldi	loop,8

RXMD_L1:	
	rcall	RX_POLL		;DMD Charactor data(8byte) Receive
	brtc	PC+2
	rjmp	ERR_RXFE	;->FE
	cpi	temp,0xff
	brne	PC+2
	rjmp	ERR_RXDAT	;(=0xff)
	st	Z+,temp
	dec	loop
	brne	RXMD_L1

	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,0xff
	breq	PC+2
	rjmp	ERR_RXDAT

	;---------DMD Charactor Set
	;		RXtemp data
	ldiw	Z,RXtemp
	rcall	DMDCHRSET

	debugp	ACK_OK
	rjmp	RXP_FIN

;------------------
RXPM_E:	;-------mode_t setting 1+1+1
	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,3		;mode_t select <3
	brcs	PC+2
	rjmp	ERR_RXDAT
	mov	temp2,temp

	rcall	RX_POLL		;=0xff receive..
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,0xff
	breq	PC+2
	rjmp	ERR_RXDAT

	mov	mode_t,temp2	
	debugp	ACK_OK
	rjmp	RXP_FIN
;------------------
RXPM_F:	;--------mode_s setting 1+1+1
	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,0x0A	;mode_s select <10
	brcs	PC+2
	rjmp	ERR_RXDAT
	mov	temp2,temp

	rcall	RX_POLL		;=0xff receive..
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,0xff
	breq	PC+2
	rjmp	ERR_RXDAT

	mov	mode_s,temp2	
	debugp	ACK_OK
	rjmp	RXP_FIN
;------------------

RXPM_G:	;-------------------Led Dim parameter set 1+18+1
	ldi	loop,18
	ldiw	Z,RXtemp
RXMG_L1:

	rcall	RX_POLL		;18times Receive (LED Dot Data)
	brtc	PC+2	
	rjmp	ERR_RXFE	;Framing ERR(T=1)
;	cpi	temp,0xff
;	brne	PC+2		;### void
;	rjmp	ERR_RXDAT	;Rxdata=0xff ->Data ERR (<18 times)
	st	Z+,temp
	dec	loop		;continue 18th
	brne	RXMG_L1

;--------
	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE	;Framing ERR(T=1)
	cpi	temp,0xff	;RXdata=0xff(finish)?
	breq	PC+2	
	rjmp	ERR_RXDAT	;->no Data ERR
				;->yes
	ldi	temp2,18	;RXtemp[0..17] ->leddot[0..17]
	ldiw	X,dim_tb
	ldiw	Z,RXtemp

RXMG_L2:
	ld	temp,Z+
	st	X+,temp
	dec	temp2
	brne	RXMG_L2
	
	debugp	ACK_OK		;Echo OK command
	rjmp	RXP_FIN

rjmp	RXP_FIN
;------------------
RXPM_H:	;-------once LED Drive 1+1+1+1
	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,60		;LED Address <60
	brcs	PC+2
	rjmp	ERR_RXDAT
	mov	temp2,temp

	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,0xff	;<>ff?
	brne	PC+2
	rjmp	ERR_RXDAT
	mov	loop,temp

	rcall	RX_POLL		;=0xff receive..
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,0xff
	breq	PC+2
	rjmp	ERR_RXDAT

	ldiw	Z,leddot
	add	ZL,temp2
	adc	ZH,ZEROR
	st	Z,loop	
	debugp	ACK_OK
	rjmp	RXP_FIN
;------------------
RXPM_I:	;-------Time Set 1+3+1
	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,24		;Time Hour <24
	brcs	PC+2
	rjmp	ERR_RXDAT
	mov	temp2,temp

	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,60		;Time Minute <60
	brcs	PC+2
	rjmp	ERR_RXDAT
	mov	loop,temp

	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,60		;Time Second <60
	brcs	PC+2
	rjmp	ERR_RXDAT
	mov	temp3,temp


	rcall	RX_POLL		;=0xff receive..
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,0xff
	breq	PC+2
	rjmp	ERR_RXDAT
	
	mov	TimeH,temp2
	mov	TimeM,loop
	mov	TimeS,temp3

	debugp	ACK_OK
	rjmp	RXP_FIN
;----------------
RXPM_J:	;--------Timeout parameter set 1+1+1
	rcall	RX_POLL
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,0xff	;=0xff receive..
	brne	PC+2
	rjmp	ERR_RXDAT
	mov	temp2,temp

	rcall	RX_POLL		;=0xff receive..
	brtc	PC+2
	rjmp	ERR_RXFE
	cpi	temp,0xff
	breq	PC+2
	rjmp	ERR_RXDAT

	sts	RXTOS,temp2	
	debugp	ACK_OK
	rjmp	RXP_FIN
;------------------
RXPM_ACK:
M_ACKL1:
	debugp	ACK_CHK
	rjmp	RXP_FIN

;--------------------
RXP_FIN:ret

;----------------------Serial mode subroutine
ERR_RXDAT:
	debugp	ACK_NG
ERR_RXDAT_1:
	rcall	RX_POLL_NT	;Rx Polling with No Time-out ERR
	brts	ERR_RXFE	;FE->reSend Echo NACK
	cpi	temp,0xff
	brne	ERR_RXDAT_1	;RxD<>FF ReRX(No Echo)

	debugp	ACK_CHK		;RxD=FF Send Echo CHK
	rjmp	RXP_FIN

ERR_RXFE:
	debugp	ACK_FE		;Flaming error
	rjmp	ERR_RXDAT_1
;------------------------------------------------------------------
