;--------------------------
SW_CNT:		;sw status control
	lds	temp,SW2_s
	cpi	temp,0
	brne	P_DI_2ON	;sw2<>00000000
	sbrs	SWFlag,Fsw2st
	ori	SWFlag,(1<<Fsw2st)+(1<<sw2on)	;Fsw2st=0 ->1 SW2on=hit
P_DI_2ON:
	lds	temp,SW2_s
	cpi	temp,0xFF
	brne	P_DI_2OFF	;sw2<>11111111
	sbrs	SWFlag,Fsw2st
	rjmp	P_DI_2OFF	;Fsw2st=0 -> no change
	andi	SWFlag,~(1<<Fsw2st)	;Fsw2st=1 -> Fsw2st=0,sw2off=hit
	ori	SWFlag,(1<<sw2off)
P_DI_2OFF:
	lds	temp,SW1_s
	cpi	temp,0
	brne	P_DI_1ON	;sw1<>00000000
	sbrs	SWFlag,Fsw1st
	ori	SWFlag,(1<<Fsw1st)+(1<<sw1on)	;Fsw1st=0 -> Fsw1st=1,SW1on=hit
P_DI_1ON:
	lds	temp,SW1_s
	cpi	temp,0xFF
	brne	P_DI_1OFF	;sw1<>11111111
	sbrs	SWFlag,Fsw1st
	rjmp	P_DI_1OFF	;Fsw1st=0 -> no change
	andi	SWFlag,~(1<<Fsw1st)	;Fsw1st=1 -> Fsw1st=0,sw1off=hit
	ori	SWFlag,(1<<sw1off)
P_DI_1OFF:
	ret



;----- sw2 dit (normal mode)
SW2DIT:
	sbrs	SWFlag,sw2on	;sw2=on?
	rjmp	PS_SW2ON	;->no
	andi	SWFlag,~(1<<sw2on)	;sw2on clear

	andi	mode_s,0b01111111
	inc	mode_s
	cpi	mode_s,8
	brcs	PS_SW2ON
	ldi	mode_s,1	;>7 ->1
	ldi	temp,1
	cp	mode_t,temp
	brne	PC+4
	ldi	temp,2
	mov	mode_t,temp	;mode_t=1->mode_t=2
	rjmp	PS_SW2ON
				;mode_t=2or other
	ldi	temp,1
	mov	mode_t,temp	;->mode_t=1
;	rjmp	PS_SW2ON
	
PS_SW2ON:
	ret
;----------------------------


;-------------------------------- sw1=on Time_Set_Mode (normal mode)
SW1DIT:

	sbrs	SWFlag,sw1on	;sw1=on?
	rjmp	PS_SW1DIT_1	;->no

	andi	SWFlag,~(1<<sw1on)	;sw1on clear

	inc	mode_tsm
	cpi	mode_tsm,7	
	brne	PS_SW1DIT_1
	clr	mode_tsm
	ldi	temp,1
	mov	mode_t,temp
PS_SW1DIT_1:

	ldiw	Z,SW1D_0
	add	ZL,mode_tsm
	adc	ZH,ZEROR	
	ijmp

SW1D_0:	rjmp	PS_SW1ON
SW1D_1:	rjmp	INI_TSM
SW1D_2:	rjmp	F_TSM
SW1D_3:	rjmp	INI_DMDDIM
SW1D_4:	rjmp	F_DMDDIM
SW1D_5:	rjmp	INI_LEDDIM
SW1D_6:	rjmp	F_LEDDIM
SW1D_7:	rjmp	PS_SW1ON
SW1D_8:	rjmp	PS_SW1ON
SW1D_9:	rjmp	PS_SW1ON
SW1D_10:rjmp	PS_SW1ON
SW1D_11:rjmp	R_TSM_1
SW1D_12:rjmp	R_TSM_2
SW1D_13:rjmp	R_TSM_3
SW1D_14:rjmp	R_TSM_4
SW1D_15:rjmp	R_TSM_5
SW1D_16:rjmp	R_TSM_6
SW1D_17:rjmp	PS_SW1ON
SW1D_18:rjmp	PS_SW1ON
SW1D_19:rjmp	PS_SW1ON
SW1D_20:rjmp	PS_SW1ON
SW1D_21:rjmp	R_DMDDIM_1
SW1D_22:rjmp	R_DMDDIM_2
SW1D_23:rjmp	PS_SW1ON
SW1D_24:rjmp	PS_SW1ON
SW1D_25:rjmp	PS_SW1ON
SW1D_26:rjmp	R_LEDDIM_1
SW1D_27:rjmp	R_LEDDIM_2
SW1D_28:rjmp	PS_SW1ON
SW1D_29:rjmp	PS_SW1ON
SW1D_30:rjmp	PS_SW1ON

;-----------------------

;----------------------
INI_TSM:
	ldiw	Z,DMD_C		;loop=0 initialize
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,'>';8
	sti	Z+,'T'
	sti	Z+,'i'
	sti	Z+,'m'
	sti	Z+,'e'
	sti	Z+,'S'
	sti	Z+,'e'
	sti	Z+,'t'
	sti	Z+,'?';16

	ldi	temp,0
	ldi	temp2,16
	sts	DMDSTA,temp
	sts	DMDNUM,temp2
	rcall	DSENDS
	clr	mode_t
	inc	mode_tsm	;->F_TSM mode
	rjmp	PS_SW1ON

F_TSM:
	sbrs	SWFlag,sw2on	;sw2=on?
	rjmp	PS_FTSM		;->no
	andi	SWFlag,~(1<<sw2on)	;sw2on clear
	ldi	mode_tsm,11	;TMS_MODE SET
PS_FTSM:rjmp	PS_SW1ON

;----------------------------------------

INI_DMDDIM:
	ldiw	Z,DMD_C		;loop=0 initialize
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,'>';7
	sti	Z+,'D'
	sti	Z+,'M'
	sti	Z+,'D'
	sti	Z+,' '
	sti	Z+,'D'
	sti	Z+,'i'
	sti	Z+,'m'
	sti	Z+,'?';15

	ldi	temp,0
	ldi	temp2,16
	sts	DMDSTA,temp
	sts	DMDNUM,temp2
	rcall	DSENDS
	clr	mode_t
	inc	mode_tsm	;->F_DMDDIM mode
	rjmp	PS_SW1ON

F_DMDDIM:
	sbrs	SWFlag,sw2on	;sw2=on?
	rjmp	PS_FDMDD		;->no
	andi	SWFlag,~(1<<sw2on)	;sw2on clear
	ldi	mode_tsm,21	;DMD_DIM mode SET
	rjmp	R_DMDDIM_15
PS_FDMDD:
	rjmp	PS_SW1ON
;---------------------------------
R_DMDDIM_1:
	sbrs	SWFlag,sw2on	;sw2=on?
	rjmp	PS_RDMDD2	;->no
	andi	SWFlag,~(1<<sw2on)	;sw2on clear
R_DMDDIM_15:
	lds	temp,DMDDIM
	inc	temp
	cpi	temp,8
	brne	PC+2
	clr	temp

	sts	DMDDIM,temp
	ldi	temp2,0x30
	add	temp2,temp
	ldiw	Z,DMD_C		;loop=0 initialize
	std	Z+15,temp2

	;-----------------
	ldi	temp2,0b10001000 ;all flash ram clear
	add	temp,temp2	 ;Dimmer parameter add
	out	PORTA,temp
	ldi	temp,0b10010011	;control word reg sel
	out	PORTB,temp
	cbi	PORTB,nWR
	nop
	sbi	PORTB,nWR
	;-----------------
	ldi	temp,8		
	sts	DMDSTA,temp

PS_RDMDD2:
	rjmp	PS_SW1ON

;-----------------------------------
R_DMDDIM_2:
	clr	mode_tsm
	ldi	temp,1
	mov	mode_t,temp
	rjmp	PS_SW1ON
;------------------------------------------------------

INI_LEDDIM:
	ldiw	Z,DMD_C		;loop=0 initialize
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,' '
	sti	Z+,'>';8
	sti	Z+,'L'
	sti	Z+,'E'
	sti	Z+,'D'
	sti	Z+,' '
	sti	Z+,'D'
	sti	Z+,'i'
	sti	Z+,'m'
	sti	Z+,'?';16

	ldi	temp,0
	ldi	temp2,16
	sts	DMDSTA,temp
	sts	DMDNUM,temp2
	rcall	DSENDS
	clr	mode_t
	inc	mode_tsm	;->F_LEDDIM mode
	rjmp	PS_SW1ON

F_LEDDIM:
	sbrs	SWFlag,sw2on	;sw2=on?
	rjmp	PS_FLEDD		;->no
	andi	SWFlag,~(1<<sw2on)	;sw2on clear
	ldi	mode_tsm,26	;DMD_DIM mode SET
	rjmp	R_LEDDIM_15
PS_FLEDD:
	rjmp	PS_SW1ON

;---------------------------------
R_LEDDIM_1:
	sbrs	SWFlag,sw2on	;sw2=on?
	rjmp	PS_RLEDD2	;->no
	andi	SWFlag,~(1<<sw2on)	;sw2on clear
R_LEDDIM_15:
	lds	temp,LEDDIM
	inc	temp
	cpi	temp,5
	brne	PS_RLEDD1
	clr	temp
PS_RLEDD1:
	sts	LEDDIM,temp

	ldi	temp2,0x30
	add	temp2,temp
	ldiw	Z,DMD_C		;loop=0 initialize
	std	Z+15,temp2
	ldi	temp,8
	sts	DMDSTA,temp

	lds	temp,LEDDIM
	cpi	temp,0
	brne	PLEDD1_P2
	ldiw	Z,dim_tb	;Z=dim_tb	
	sti	Z+,0xF0
	sti	Z+,0xF8
	sti	Z+,0xE0
	sti	Z+,0xDC
	sti	Z+,0xF0
	sti	Z+,0xE8
	sti	Z+,0xF0
	sti	Z+,0xF8
	sti	Z+,0x87
	sti	Z+,0xF8
	sti	Z+,0xF0
	sti	Z+,0xE8
	sti	Z+,0xD4
	sti	Z+,0xF8
	sti	Z+,0xE0
	sti	Z+,0xF8
	sti	Z+,0xF0
	sti	Z+,0x8F

	rjmp	PS_RLEDD2
PLEDD1_P2:
	cpi	temp,1
	brne	PLEDD1_P3
	ldiw	Z,dim_tb	;Z=dim_tb SOLI1
	sti	Z+,0xE0
	sti	Z+,0xF0
	sti	Z+,0xC8
	sti	Z+,0xF4
	sti	Z+,0xE0
	sti	Z+,0x9A
	sti	Z+,0xE0
	sti	Z+,0xF0
	sti	Z+,0xCD
	sti	Z+,0xF0
	sti	Z+,0xE0
	sti	Z+,0x9A
	sti	Z+,0xE4
	sti	Z+,0xF0
	sti	Z+,0xC8
	sti	Z+,0xF0
	sti	Z+,0xE0
	sti	Z+,0x9F

	rjmp	PS_RLEDD2

PLEDD1_P3:
	cpi	temp,2
	brne	PLEDD1_P4
	ldiw	Z,dim_tb	;Z=dim_tb HALF
	sti	Z+,0x00
	sti	Z+,0xC0
	sti	Z+,0x20
	sti	Z+,0xD8
	sti	Z+,0x00
	sti	Z+,0xE4
	sti	Z+,0x10
	sti	Z+,0x80
	sti	Z+,0x6B
	sti	Z+,0x80
	sti	Z+,0x50
	sti	Z+,0xA4
	sti	Z+,0x48
	sti	Z+,0x90
	sti	Z+,0x60
	sti	Z+,0x80
	sti	Z+,0x00
	sti	Z+,0xFF
	rjmp	PS_RLEDD2

PLEDD1_P4:
	cpi	temp,3
	brne	PLEDD1_P5
	ldiw	Z,dim_tb	;Z=dim_tb HALFHALF
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0x80
	sti	Z+,0x70
	sti	Z+,0x00
	sti	Z+,0x8C
	sti	Z+,0x40
	sti	Z+,0x00
	sti	Z+,0xB3
	sti	Z+,0x00
	sti	Z+,0x40
	sti	Z+,0x8C
	sti	Z+,0x30
	sti	Z+,0x40
	sti	Z+,0x80
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0xFF
	rjmp	PS_RLEDD2
PLEDD1_P5:
	ldiw	Z,dim_tb	;Z=dim_tb dim_3 ONLY
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0xFF
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0xFF
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0x00
	sti	Z+,0xFF
	rjmp	PS_RLEDD2


PS_RLEDD2:
	rjmp	PS_SW1ON
;--------------------------------------
R_LEDDIM_2:
	clr	mode_tsm
	ldi	temp,1
	mov	mode_t,temp
	rjmp	PS_SW1ON
;----------------------------------------
;-----------------------
R_TSM_1:

	clr	mode_t		;DMD increment stop
	sts	TSM_TH,TimeH
	sts	TSM_TM,TimeM
	rcall	DMD_TSM
	inc	mode_tsm	;TSM ->next
	rjmp	PS_SW1ON		

R_TSM_2:
				;DMD charactor send with scroll
				; 0b11(2)1(1)(0)11 charactor ram
				; PORTB: A4,A3,A2,nWR,A1,A0,nFL,nRST

	outi	PORTA,0b00000001	;blink=on
	outi	PORTB,0b00010001	;FL=ON/A=[0,0,0] select
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	sbrs	SWFlag,sw2on	;sw2=on?
	rjmp	PS_TSM_2	;->no
	andi	SWFlag,~(1<<sw2on)	;sw2on clear
	lds	temp,TSM_TH
	ldi	temp2,10
	add	temp,temp2
	cpi	temp,30
	brcs	PC+2		;under 29H
	subi	temp,30		;over 30H ->-30
	sts	TSM_TH,temp
	rcall	DMD_TSM
PS_TSM_2:
	rjmp	PS_SW1ON
;------------------------
R_TSM_3:
	;brink
	outi	PORTA,0b00000000	;blink=off
	outi	PORTB,0b00010001	;FL=ON/A=[0,0,0] select
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive
	outi	PORTA,0b00000001	;blink=on
	outi	PORTB,0b00010101	;FL=ON/A=[0,0,1] select
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	sbrs	SWFlag,sw2on	;sw2=on?
	rjmp	PS_TSM_3	;->no
	andi	SWFlag,~(1<<sw2on)	;sw2on clear
	lds	temp,TSM_TH
	inc	temp			;+1h

	mov	temp2,temp
L_TSM3_1:	
	cpi	temp2,10
	brcs	L_TMS3_2
	subi	temp2,10
	rjmp	L_TSM3_1
L_TMS3_2:
	cpi	temp2,0
	brne	L_TMS3_3
	subi	temp,10
L_TMS3_3:
	sts	TSM_TH,temp
	rcall	DMD_TSM

PS_TSM_3:
	rjmp	PS_SW1ON

;---------------------
R_TSM_4:
	;brink
	outi	PORTA,0b00000000	;blink=off
	outi	PORTB,0b00010101	;FL=ON/A=[0,0,1] select
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive
	outi	PORTA,0b00000001	;blink=on
	outi	PORTB,0b00011101	;FL=ON/A=[0,1,1] select
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	sbrs	SWFlag,sw2on	;sw2=on?
	rjmp	PS_TSM_4	;->no
	andi	SWFlag,~(1<<sw2on)	;sw2on clear
	lds	temp,TSM_TM
	ldi	temp2,10
	add	temp,temp2		;+10m

	cpi	temp,60
	brcs	L_TSM4_1
	subi	temp,60
L_TSM4_1:
	sts	TSM_TM,temp
	rcall	DMD_TSM

PS_TSM_4:
	rjmp	PS_SW1ON
;----------------------------
R_TSM_5:
	;brink
	outi	PORTA,0b00000000	;blink=off
	outi	PORTB,0b00011101	;FL=ON/A=[0,1,1] select
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive
	outi	PORTA,0b00000001	;blink=on
	outi	PORTB,0b00110001	;FL=ON/A=[1,0,0] select
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	sbrs	SWFlag,sw2on	;sw2=on?
	rjmp	PS_TSM_5	;->no
	andi	SWFlag,~(1<<sw2on)	;sw2on clear
	lds	temp,TSM_TM
	inc	temp			;+1m

	mov	temp2,temp
L_TSM5_1:	
	cpi	temp2,10
	brcs	L_TMS5_2
	subi	temp2,10
	rjmp	L_TSM5_1
L_TMS5_2:
	cpi	temp2,0
	brne	L_TMS5_3
	subi	temp,10
L_TMS5_3:
	sts	TSM_TM,temp
	rcall	DMD_TSM

PS_TSM_5:
	rjmp	PS_SW1ON
;--------------------
R_TSM_6:
	outi	PORTA,0b00000000	;blink=off
	outi	PORTB,0b00110001	;FL=ON/A=[1,0,0] select
	cbi	PORTB,nWR	;wr active
	nop
	sbi	PORTB,nWR	;wr inactive

	clr	mode_tsm	;TSM->mode0
	lds	temp,TSM_TH
	cpi	temp,24		;over 24H?
	brcs	L_TMS6_1
	subi	temp,24		;yes-> -24h
L_TMS6_1:
	mov	TimeH,temp

	lds	TimeM,TSM_TM
	clr	TimeS
	clr	frame
	ldi	temp,1
	mov	mode_t,temp
	rcall	DOTACLR
	rjmp	PS_SW1ON
		

PS_SW1ON:
	ret
